# Copyright 2021 Research Institute of Systems Planning, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


class TimerControl:

    def __init__(self, timer_handle: int, timestamp: int) -> None:
        self._timer_handle = timer_handle
        self._timestamp = timestamp

    @property
    def timer_handle(self) -> int:
        return self._timer_handle

    @property
    def timestamp(self) -> int:
        return self._timestamp


class TimerInit(TimerControl):

    def __init__(self, timer_handle: int, timestamp: int, period_ns: int) -> None:
        super().__init__(timer_handle, timestamp)
        self._period_ns = period_ns

    @property
    def period_ns(self) -> int:
        return self._period_ns
